//--------------------------------------------------
//Headerfile: main.cpp
//Beschreibung: Studentendatenbank OOP
//Autor:  Tobias Schwalb, ITIV
//Erstellt: 20.06.2011
//Version: 1.2
//--------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
#include "student.h"
#include "studDatabase.h"
using namespace std;

void daten_hinzufuegen( StudDatabase* database ); 
void daten_suchen( StudDatabase* database ); 
void daten_loeschen( StudDatabase* database );
void daten_ausgabe( StudDatabase* database );


int main() {
  StudDatabase* database = new StudDatabase;
	
	int auswahl;

  do {
    cout << endl;
	  cout << "Studentendatenbank" << endl;
	  cout << "==================" << endl << endl;
   	  cout << "(1) Eintrag hinzufuegen" << endl;
	  cout << "(2) Eintrag suchen" << endl;
	  cout << "(3) Eintrag loeschen" << endl;
	  cout << "(4) Datenbank ausgeben" << endl;
	  cout << "(5) Ende" << endl;
	  cout << "Bitte auswaehlen: ";
	  cin >> auswahl;
	  cin.clear();
	  cin.sync();
	
	  switch(auswahl) {
	    case 1: daten_hinzufuegen( database ); break;
	    case 2: daten_suchen( database ); break;
	    case 3: daten_loeschen( database ); break;
	    case 4: daten_ausgabe( database ); break;
	    case 5: break;
	    default: cout << "Ihre Eingabe ist falsch, die Option steht nicht zur Verfuegung";
	  }
  } while( auswahl != 5 );

  delete database;
}


void daten_hinzufuegen( StudDatabase* database ) {
  string name;
  string vorname;
  int matrikelNr;
  int note;  
  
  cout << endl << "Bitte die neuen Daten eingeben" << endl;
  cout << "Name: ";
  cin >> name;
  cout << "Vorname: ";
  cin >> vorname;
  cout << "Matrikelnummer: ";
  cin >> matrikelNr;
  cout << "Note: ";
  cin >> note;

  database->hinzufuegen( name, vorname, matrikelNr, note );
}


void daten_suchen( StudDatabase* database ) {
  int matrikelNr;
  
  cout << "Bitte zu suchende Matrikelnummer eingeben: ";
  cin >> matrikelNr;

  Student* gesucht = database->suchen( matrikelNr );
  if( gesucht != NULL ) {
    gesucht->displayData();
  } else {
    cout << "Matrikelnummer in Datenbank nicht gefunden" << endl;
  }
}


void daten_loeschen( StudDatabase* database ) {
  int matrikelNr;
  
  cout << "Bitte zu loeschende Matrikelnummer eingeben: ";
  cin >> matrikelNr;

  Student* gesucht = database->suchen( matrikelNr );
  if( gesucht != NULL ) {
    database->loeschen( gesucht );
  } else {
    cout << "Matrikelnummer in Datenbank nicht gefunden" << endl;
  }
}


void daten_ausgabe( StudDatabase* database ) {
  database->ausgabe();
}
