//--------------------------------------------------
//Headerfile: studDatabase.cpp
//Beschreibung: Studentendatenbank OOP
//Autor:  Tobias Schwalb, ITIV
//Erstellt: 20.06.2011
//Version: 1.2
//--------------------------------------------------

#include <iomanip>
#include "student.h"
#include "studDatabase.h"


StudDatabase::StudDatabase() {
  start = NULL;
  ende = NULL;
}


StudDatabase::~StudDatabase() {
  while(start != NULL) {
    loeschen(start);
  }
}


void StudDatabase::hinzufuegen( string name, string vorname, int matrikelnr, double note ) {
  Student* neu = new Student;  
  if( start == NULL ) {
    start = neu;
  } else {
	ende->setNext( neu );
  }
	
  ende = neu;
  neu->setNext( NULL );

  neu->setData( name, vorname, matrikelnr, note );
}


Student* StudDatabase::suchen( int matrikelnr ) {
  Student* gesucht = NULL; 
  for( Student* ptr_stud = start; ptr_stud != NULL; ptr_stud = ptr_stud->getNext() ) {
	  if (matrikelnr == ptr_stud->getMatrikelnr() ) {
	    gesucht = ptr_stud;
	    break;
	  }
  }
  return gesucht;
}


void StudDatabase::loeschen( Student* zuLoeschen ) {
  Student* zeigt_geloescht = start;

  if( zuLoeschen == start && zuLoeschen == ende ) {
    start = NULL;
    ende = NULL;
    delete zuLoeschen;
  } else if( zuLoeschen == start ) {
	  start = zuLoeschen->getNext();
	  delete zuLoeschen;
  } else {
	  for( zeigt_geloescht = start; zeigt_geloescht->getNext() != zuLoeschen; zeigt_geloescht = zeigt_geloescht->getNext() );	
	  zeigt_geloescht->setNext( zuLoeschen->getNext() );
	  delete zuLoeschen;				
	  if( zeigt_geloescht->getNext() == NULL ) {
	    ende = zeigt_geloescht;
	  }
  }
  cout << "--> Loeschung Erfolgreich" << endl;
}


void StudDatabase::ausgabe() {
  Student* ptr_stud = start;
	
  cout << endl << setw( 12 ) << "Name" << setw( 12 ) << "Vorname" << setw( 12 ) << "Matrikelnr" << setw( 12 ) << "Note" << endl;
  cout << "---------------------------------------------------------------" << endl;

  if( start == NULL ) {
    cout << "--> Datenbank ist Leer" << endl;
  } else {
	  for( ptr_stud = start; ptr_stud != NULL; ptr_stud = ptr_stud->getNext() ) {
	    cout << setw( 12 ) << ptr_stud->getName() << setw( 12 ) << ptr_stud->getVorname() << setw( 12 ) << ptr_stud->getMatrikelnr() << setw( 12 ) << ptr_stud->getNote() << endl;
	  }
  }
}