#include "dictionary.h"
#include <fstream>

Dictionary::Dictionary( string _filename ) {
    filename=_filename;
    readFile();
}

string Dictionary::searchEnglish( string searchString ) {

    map<string,string>::iterator mapIterator;
    mapIterator = engGerMap.find( searchString );

    if ( mapIterator != engGerMap.end() ) {
        return mapIterator->second;
    }
    else return "not in map";
}

string Dictionary::searchGerman( string searchString ) {

    map<string,string>::iterator mapIterator;
    mapIterator=gerEngMap.find( searchString );

    if ( mapIterator != gerEngMap.end() ) {
        return mapIterator->second;
    }
    else return "not in map";
}

void Dictionary::add( string germanWord, string englishWord ) {
    gerEngMap[germanWord]=englishWord;
    engGerMap[englishWord]=germanWord;
}

void Dictionary::readFile() {

    fstream myFile( filename.c_str(), ios::in );

    if(myFile) {
        // Die Datenbank Datei existiert bereits
        string germanWord,englishWord;
        while( myFile >> germanWord >> englishWord ) {
            gerEngMap[germanWord]=englishWord;
            engGerMap[englishWord]=germanWord;
        }
        myFile.clear();
    }
    else {
        // Datenbank Datei wird angelegt
        myFile.open( filename.c_str(), ios::out );
    }
    myFile.close();
}

void Dictionary::saveToFile() {
    fstream myFile( filename.c_str(), ios::out );
    map<string, string>::iterator mapIterator;

    for( mapIterator = gerEngMap.begin(); mapIterator != gerEngMap.end(); mapIterator++ ) {
        myFile << mapIterator->first << " " << mapIterator->second << endl;
    }

    myFile.close();
}
